<template>
  <el-dialog title="调整成本" :visible.sync="dialogVisible" width="600px" @close="cancelSubmit()">
    <div v-loading="loading">
      <div v-if="goodsSkuList.length > 1">
        <el-table :data="goodsSkuList" :span-method="objectSpanMethod" border>
          <el-table-column width="140px" v-for="(i, k) in skuCols" :label="i" :key="k" :class-name="k == skuCols.length - 1 ? 'pad-l-20' : 'right-border'">
            <template slot-scope="scope">{{ scope.row.cols[k] }}</template>
          </el-table-column>
          <el-table-column label="成本(元)">
            <template slot="header">
              <span>成本(元)</span>
              <el-popover placement="top" trigger="click">
                <dm-input v-model="banthCost" class="hidden-limit"></dm-input>
                <div class="popver-button" style="margin-top:18px;text-align:right">
                  <el-button type="dafault" size="small">取消</el-button>
                  <el-button type="primary" size="small" class="ml10 ml10" @click="handleBatch">确认</el-button>
                </div>
                <el-tooltip slot="reference" content="批量编辑">
                  <i class="el-icon-edit-outline"></i>
                </el-tooltip>
              </el-popover>
            </template>
            <template slot-scope="scope">
              <dm-input-amount width="200px" @change="changeSingleCost(skuSellObj[scope.row.mapId].giftSkuId, skuSellObj[scope.row.mapId].giftSkuCostPrice)" v-model.trim="skuSellObj[scope.row.mapId].giftSkuCostPrice" precision="2" :min="0" :max="999999.99"></dm-input-amount>
            </template>
          </el-table-column>
        </el-table>
      </div>
      <el-form class="mt20" v-else>
        <el-form-item label="成本费用" required>
          <template>
            <dm-input-amount v-model="costPrice" @change="changeSingleCost(giftSkuId, costPrice)" precision="2" :min="0" :max="999999.99"  style="width:200px"></dm-input-amount>
          </template>
        </el-form-item>
      </el-form>
      <el-form class="mt20">
        <el-form-item label="调整备注" required>
          <template>
            <el-input style="width:260px" type="textarea" :rows="3" placeholder="请填入调整备注" v-model="textarea" :maxlength="240" show-word-limit></el-input>
          </template>
        </el-form-item>
      </el-form>
    </div>
    <div slot="footer" class="dialog-footer">
      <el-button @click="cancelSubmit()">取消</el-button>
      <el-button type="primary" @click="submitProNanme()">确认</el-button>
    </div>
  </el-dialog>
</template>

<script>
import api from '@/api/gift.js';
const { realCostUpdate, giftGet } = api;
import { deepClone } from '../../../utils/index';
export default {
  props: {
    updateCostData: {
      type: Object,
      default() {
        return {};
      }
    }
  },
  data() {
    return {
      dialogVisible: false,
      loading: false,
      // costChangeObj: [], // 用于存放批量修改后的数据
      banthCost: '',
      updateList: [],
      textarea: '',
      giftId: '',
      skuSellObj: {},
      goodsStandardInfo: '',
      skuCols: [], // 存放sku组合数据
      costPrice: '',
      giftSpecInfo: '',
      goodsSkuList: [],
      stockObj: {},
      giftSkuId: ''
    };
  },
  mounted() {
    this.dialogVisible = true;
    this.giftId = this.updateCostData.id;
    this.getData();
  },
  methods: {
    getData(){
      if(this.loading) return;
      let params = {
        id: this.giftId
      };
      giftGet(params).then(res =>{
        if(res.code === '0000'){
          this.giftSpecInfo = res.result.giftSpecInfo;
          let skuList = res.result.skuList || []; // 礼品规格值信息

          let mapData = [];
          let skuSellObj = {};
          if (skuList.length > 0) {
            for (let i = 0; i < skuList.length; i++) {
              mapData.push({
                mapId: '',
                id: [],
                giftSkuId: skuList[i].giftSkuId,
                giftSkuCostPrice: skuList[i].giftSkuCostPrice, // 成本价
                giftSkuCode: skuList[i].giftSkuCode, // sku编码
                skuBarCode: skuList[i].skuBarCode, // 礼品条形码
                stock: skuList[i].stock, // 库存
                remainedStock: skuList[i].remainedStock, // 库存
                giftSkuStrand: skuList[i].giftSkuStrand, // 礼品sku规格信息
                giftId: skuList[i].giftId
              });
              for (let j = 0; j < JSON.parse(skuList[i].giftSkuStrand).length; j++) {
                mapData[i].id.push(JSON.parse(skuList[i].giftSkuStrand)[j].specStandardValueId);
              }
              mapData[i].mapId = mapData[i].id.join('_');
            }
            for (let item of mapData) {
              skuSellObj[item.mapId] = {
                skuBarCode: item.skuBarCode,
                giftSkuCode: item.giftSkuCode,
                giftSkuCostPrice: item.giftSkuCostPrice,
                stock: item.stock,
                giftSkuCostPriceStatus: true,
                stockStatus: true,
                giftSkuId: item.giftSkuId,
                remainedStock: item.remainedStock,
              };
            }
            console.log(skuSellObj);
            this.skuSellObj = deepClone(skuSellObj);
            console.log(this.skuSellObj);
          }
          this.goodsStandardInfo = JSON.parse(this.giftSpecInfo); // 礼品规格信息
          console.log(this.goodsStandardInfo);
          if (this.goodsStandardInfo.length > 0) {
            this.isStdImg = this.goodsStandardInfo[0].standardimg === 2 ? true : false;
          } else {
            this.isStdImg = false;
          }
          if (this.goodsStandardInfo.length > 0) {
            this.getSkuList();
          }
        }
      });
      console.log('获取成本数据');
    },
    // 获取sku数据
    getSkuList() {
      console.log(this.goodsStandardInfo);
      let goodsStandardInfoCopy = deepClone(this.goodsStandardInfo);
      let arr = [];
      this.skuCols = [];
      /** ****组合sku的数据*****/
      for (let item of goodsStandardInfoCopy) {
        for (let i of item.valueList) {
          i.specStandardName = item.specName;
          i.specStandardId = item.specId;
        }
        this.skuCols.push(item.specName);
        arr.push(item.valueList);
      }
      let arrCopy = this.combine(deepClone(arr));
      let goodsSkuList = [];
      for (let i = 0; i < arrCopy.length; i++) {
        goodsSkuList.push({
          data: arrCopy[i],
          cols: [],
          id: [],
          mapId: ''
        });
        for (let j = 0; j < arrCopy[i].length; j++) {
          goodsSkuList[i].cols.push(arrCopy[i][j].specStandardValueName);
          goodsSkuList[i].id.push(arrCopy[i][j].specStandardValueId);
        }
        goodsSkuList[i].mapId = goodsSkuList[i].id.join('_');
      }
      this.goodsSkuList = deepClone(goodsSkuList);
      /** ****获取合并单元格的数组值start *****/
      let numArr = [];
      this.stValCount = [];
      for (let k = 0; k < goodsStandardInfoCopy.length; k++) {
        if (goodsStandardInfoCopy[k].valueList.length > 0) {
          numArr[k] = goodsStandardInfoCopy[k].valueList.length;
        }
      }
      let num = 1;
      for (let m = 0; m < numArr.length; m++) {
        num = num * numArr[m];
        this.stValCount[m] = num;
      }
      /** ****获取合并单元格的数组值 this.stValCount   end *****/

      // 组合sku的销售值信息 价格，库存，sku编码 ，商品条形码
      let goodsSkuListCopy = deepClone(goodsSkuList);
      let skuSellObjCopy = deepClone(this.skuSellObj);

      this.skuSellObj = {};

      for (let item of goodsSkuListCopy) {
        if (skuSellObjCopy[item.mapId]) {
          this.skuSellObj[item.mapId] = {
            giftSkuCostPrice: Object.keys(skuSellObjCopy).length > 0 ? skuSellObjCopy[item.mapId].giftSkuCostPrice : '',
            stock: Object.keys(skuSellObjCopy).length > 0 ? skuSellObjCopy[item.mapId].stock : '',
            giftSkuCode: Object.keys(skuSellObjCopy).length > 0 ? skuSellObjCopy[item.mapId].giftSkuCode : '',
            skuBarCode: Object.keys(skuSellObjCopy).length > 0 ? skuSellObjCopy[item.mapId].skuBarCode : '',
            giftSkuId: Object.keys(skuSellObjCopy).length > 0 ? skuSellObjCopy[item.mapId].giftSkuId : '',
            stockStatus: true,
            giftSkuCostPriceStatus: true,
          };
          this.stockObj[item.mapId] = Object.keys(skuSellObjCopy).length > 0 ? skuSellObjCopy[item.mapId].stock : '';
        } else {
          this.skuSellObj[item.mapId] = {
            giftSkuCostPrice: '',
            stock: undefined,
            giftSkuCode: '',
            skuBarCode: '',
            stockStatus: true,
            giftSkuCostPriceStatus: true,
            giftSkuId: ''
          };
        }
      }
      this.skuSellObj = deepClone(this.skuSellObj);
      this.costPrice = this.skuSellObj[this.goodsSkuList[0].mapId].giftSkuCostPrice;
      this.giftSkuId = this.skuSellObj[this.goodsSkuList[0].mapId].giftSkuId;
      this.refash = !this.refash;
    },
    combine(arr) {
      arr.reverse();
      let r = [];

      (function f(t, a, n) {
        if (n == 0) return r.push(t);
        for (let i = 0; i < a[n - 1].length; i++) {
          f(t.concat(a[n - 1][i]), a, n - 1);
        }
      })([], arr, arr.length);
      // var t = r;
      return r; // r是排列组合后的数据与
    },
    submitProNanme() {
      if(this.loading) return;
      if(!this.textarea){
        this.$message.error('请完善备注');
      }
      this.loading = true;
      let params = {
        giftId: this.updateCostData.id,
        updateList: this.updateList,
        remark: this.textarea
      };
      realCostUpdate(params).then(res => {
        if(res.code === '0000'){
          this.dialogVisible = false;
          setInterval(() => {
            this.$emit('closeUpdateCost', false);
          }, 10);
          this.$message.success('修改成功');
        }else{
          this.$message.error(res.message);
        }
      }).finally(() => this.loading = false);
    },
    // 取消修改
    cancelSubmit() {
      this.dialogVisible = false;
      setInterval(() => {
        this.$emit('closeUpdateCost', false);
      }, 10);
    },
    objectSpanMethod({ rowIndex, columnIndex }) {
      let len = this.stValCount.length;
      if (columnIndex < len) {
        let count1 = this.stValCount[columnIndex];
        let count2 = this.stValCount[len - 1];
        if (!(count1 && count2)) {
          return { rowspan: 0, colspan: 0 };
        }
        let rowspan = count2 / count1;
        if (rowIndex % rowspan === 0) {
          return { rowspan, colspan: 1 };
        } else {
          return { rowspan: 0, colspan: 0 };
        }
      }
    },
    // 批量修改成本
    handleBatch(){
      console.log(this.banthCost);
      this.updateList = [];
      for(let item in this.skuSellObj){
        this.skuSellObj[item].giftSkuCostPrice = this.banthCost;
        this.updateList.push({ giftSkuId: this.skuSellObj[item].giftSkuId, costPrice: this.skuSellObj[item].giftSkuCostPrice });
      }
      console.log(this.updateList);
    },
    changeSingleCost(id, cost){
      console.log(id);
      if(!cost){
        this.$message.error('请完善成本');
      }
      if(this.updateList.length > 0){
        let iii;
        let result = this.updateList.some((item, index) =>{
          if(item.giftSkuId == id){
            iii = index;
            return true;
          }
        });
        if(result){ // 如果存在
          this.updateList[iii].costPrice = cost;
        }else{
          this.updateList.push({ giftSkuId: id, costPrice: cost });
        }
      }else{
        this.updateList.push({ giftSkuId: id, costPrice: cost });
      }
    }
  }
};
</script>
<style scoped></style>
<style>
.right-border {
  border-right: 1px solid #ebeef5;
}
.hidden-limit .dm-input__counter{
  display: none;
}
.popver-button .el-button:not(.el-button--text) {
  min-width: 50px;
}
</style>